# Contributions 
In lieu of a formal styleguide, take care to maintain the existing coding style ensuring there are no linting errors. Add unit tests for any new or changed functionality. Lint and test your code using the npm scripts below:

### NPM tasks
| Task                 | Usage                                                        |
| -------------------- | ------------------------------------------------------------ |
| `npm run start`      | Fire up local server for development                         |
| `npm run test`       | Run sequence of tests once                                   |
| `npm run test:watch` | Fire up test server and re-test on file change               |
| `npm run js:build`   | Compile Choices to an uglified JavaScript file               |
| `npm run css:watch`  | Watch SCSS files for changes. On a change, run build process |
| `npm run css:build`  | Compile, minify and prefix SCSS files to CSS                 |

## Pull requests
When submitting a pull request that resolves a bug, feel free to use the following template:

```md
## This is the problem:

## Steps to reproduce:

## This is my solution:
```
